%{

  open Instr

%}

%start instrs_eof
%type <Instr.instruction list> instrs_eof

/*s Tokens */

/* Literals */

%token <int> INT

%token SENSE MARK UNMARK PICKUP DROP TURN MOVE FLIP 
%token HERE AHEAD LEFTAHEAD RIGHTAHEAD 
%token FRIEND FOE FRIENDWITHFOOD FOEWITHFOOD FOOD 
%token ROCK MARKER FOEMARKER HOME FOEHOME 
%token LEFT RIGHT 
%token EOF EOL

%%

instrs_eof:
| instrs EOF
    { List.rev $1 }
;

instrs:
| /* $\varepsilon$ */    
  { [] }
| instrs instr EOL
  { $2::$1 }
;

instr:
| SENSE sense_dir state state condition  
    { Sense($2,$3,$4,$5) }
| MARK marker state
    { Mark($2,$3) }
| UNMARK marker state
    { Unmark($2,$3) }
| PICKUP state state
    { PickUp($2,$3) }
| DROP state
    { Drop $2 }
| TURN left_or_right state
    { Turn($2,$3) }
| MOVE state state
    { Move($2,$3) }
| FLIP INT state state
    { Flip($2,$3,$4) }
;

sense_dir:
| HERE 
    { Here }
| AHEAD 
    { Ahead }
| LEFTAHEAD 
    { LeftAhead }
| RIGHTAHEAD 
    { RightAhead }
;

state:
| INT { $1 }
;

condition:
| FRIEND 
    { Friend }
| FOE 
    { Foe }
| FRIENDWITHFOOD 
    { FriendWithFood }
| FOEWITHFOOD 
    { FoeWithFood }
| FOOD 
    { Food }
| ROCK 
    { Rock }
| MARKER INT
    { Marker $2 }
| FOEMARKER 
    { FoeMarker }
| HOME 
    { Home }
| FOEHOME 
    { FoeHome }
;

marker:
| INT { $1 }
;



left_or_right:
| LEFT 
    { Left }
| RIGHT 
    { Right }
;
