
type label=string
type marker=int

type dir=
    Ahead
  | Here
  | ARight
  | ALeft

type sense=
    Friend
  | Foe
  | FriendWithFood
  | FoeWithFood
  | Food
  | Rock
  | Marker of marker
  | FoeMarker
  | Home
  | FoeHome

type pred=
    Flip of int
  | Sense of sense*dir

type cond=
    Pred of pred
  | Not of cond
  | Or of cond*cond
  | And of cond*cond
  | True
  | False

type left_or_right=
    Left  
  | Right

type instr=
    If of cond*body*body
  | While of cond*body
  | Repeat of cond*body
  | Mark of marker
  | Unmark of marker
  | Pickup of label
  | Move of label
  | Drop
  | Turn of left_or_right
  | Goto of label
  | Return
  | Seq of body
  | Call of string*(label list)
  | Lbl of label
and body= instr list 

type procedure={name:string;args:string list;body:body}

type prog={main:body;procs:procedure list}

