%{

  open Ast

%}

%token <int> INT
%token <string> IDENT

%token MARK 
%token UNMARK
%token PICKUP
%token DROP 
%token LTURN 
%token RTURN
%token MOVE 
%token FLIP 
%token HERE AHEAD LEFTAHEAD RIGHTAHEAD 
%token FRIEND FOE FRIENDWITHFOOD FOEWITHFOOD FOOD 
%token ROCK 
%token MARKER 
%token FOEMARKER HOME FOEHOME 
%token PLUS BOUCLE NOPBOUCLE POINT EQ NON
%token LP RP CG CD
%token STAR
%token EOF EOL

%left PLUS BOUCLE NOPBOUCLE
%left POINT
%nonassoc dum

%start prog
%type <Ast.prg> prog

%%

prog:
| macros expr EOF     { List.rev $1 , $2 }
;

macros:
| macro               { [$1] }
| macros macro        { $2::$1 }
|                     { [] }
;

macro:
| IDENT EQ expr       { $1,$3 }
;

expr:
| action              { Action $1 }
| IDENT               { Ident $1 }
| expr PLUS expr      { Plus($1,$3) }
| expr BOUCLE expr    { Whilenot($1,$3) }
| expr NOPBOUCLE      { Nopwhile $1 }
| expr POINT expr     { Seq($1,$3) }
| expr STAR           { Star $1}
| NON expr %prec dum  { Non $2 }
| LP expr RP          { $2 }
;


action:
| MARK LP INT RP      { Mark $3 }
| UNMARK LP INT RP    { Unmark $3 }
| PICKUP              { Pickup }
| DROP                { Drop }
| LTURN               { Lturn }
| RTURN               { Rturn }
| MOVE                { Move }
| FLIP LP INT RP      { Flip $3 }
| cond LP dir RP      { Sense($1,$3) }
;

dir:
| HERE                { Here }
| AHEAD               { Ahead }
| LEFTAHEAD           { Lahead }
| RIGHTAHEAD          { Rahead }
;

cond:
| FRIEND              { Friend }
| FOE                 { Foe }
| FRIENDWITHFOOD      { Friendwithfood }
| FOEWITHFOOD         { Foewithfood }
| FOOD                { Food }
| ROCK                { Rock }
| MARKER CG INT CD    { Marker $3 }
| FOEMARKER           { Foemarker }
| HOME                { Home }
| FOEHOME             { Foehome }
;

