(* Localisation des erreurs lexicales et syntaxiques *)
open Format
 

(* Affiche le numro de la ligne du fichier source ifile correspondant
    la position absolue p d'une erreur lexicale ou syntaxique. *)
   
let position ifile p =
  let f = open_in ifile in
  let cptchar = ref 0 
  and cptligne = ref 1 in
    try
      while !cptchar<p do
	let c = input_char f in
	  if c = '\n' then incr cptligne;
	  incr cptchar;
      done;
      close_in f;
      eprintf "Fichier \"%s\", ligne %d\n@?" ifile !cptligne
    with End_of_file -> 
      eprintf 
	"Impossible de localiser l'erreur de syntaxe dans le fichier \"%s\"\n@?" 
	ifile
	
