
let rec gcd l =
  match l with
    | [] -> assert false
    | [x] -> x
    | _ -> gcd_sort (List.sort (-) l)

and gcd_sort l =
  match l with
    | [] -> assert false
    | [x] -> x
    | 0::l -> gcd_sort l
    | x::l -> gcd (x::(List.map (fun y -> y mod x) l))
;;

type 'a t =
  | Flip of int * 'a t * 'a t
  | Leaf of 'a


let rec split sum sumpart l (n,a) r =
  let newsum = sumpart + n in
  if newsum >= sum - newsum
  then (newsum,l,(n,a),r) else
    match r with
      | [] -> assert false
      | (m,b)::rem ->
	  split sum newsum ((n,a)::l) (m,b) rem
;;
  
let rec build (l : (int * 'a) list) =
  match l with
    | [] -> assert false
    | [_,x] -> Leaf x
    | _ ->
	let d = gcd (List.map fst l) in
	let gl = List.map (fun (x,a) -> (x / d,a)) l in
	(* trie en decroissant *)
	let ol = List.sort (fun (x1,_) (x2,_) -> x2 - x1) gl in
	let sum = List.fold_left (fun a (x,_) -> a+x) 0 ol in 
	match ol with
	  | [] -> assert false
	  | (n,elt)::r ->
	      let t,l,(n,elt),r = split sum 0 [] (n,elt) r in 
	      let q = t / (sum - t) in
	      let dd = gcd [sum;q+1] in
	      let m = (q+1)/dd in
	      let b = m * t - q * (sum / dd) in
	      let a = m * n - b in
	      let l = List.map (fun (y,elt) -> (y * m,elt)) l in
	      let r = List.map (fun (y,elt) -> (y * m,elt)) r in
	      Flip (q+1, 
		build (if a=0 then l else (a,elt)::l),
		build (if b=0 then r else (b,elt)::r))
;;
	      
