
(* a decision tree is either a leaf (only one choice, ie no decision)
  or a flip with parameter n, which decides to go on the left subtree
  of random n <> 0 and on the right otherwise *)

type 'a t =
  | Flip of int * 'a t * 'a t
  | Leaf of 'a

(* build [(n1,e1) ; .. (nk, ek) ] builds a decision tree between
   elements e1, .. , ek with probabiliy p(e_i) = n_i / (n1 + .. + nk) *)
   
val build : (int * 'a) list -> 'a t
